<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Features.Verbal</span><span>
</span><span id="line-2"></span><span>  </span><span class="hs-special">(</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier">VF</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-3"></span><span>    </span><span class="annot"><a href="Features.Verbal.html#Aspect"><span class="hs-identifier">Aspect</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-4"></span><span>    </span><span class="annot"><a href="Features.Verbal.html#Tense"><span class="hs-identifier">Tense</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-5"></span><span>    </span><span class="annot"><a href="Features.Verbal.html#Instantiation"><span class="hs-identifier">Instantiation</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-6"></span><span>    </span><span class="annot"><a href="Features.Verbal.html#fullVerb"><span class="hs-identifier">fullVerb</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-7"></span><span>    </span><span class="annot"><a href="Features.Verbal.html#lexicalVerb"><span class="hs-identifier">lexicalVerb</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-8"></span><span>    </span><span class="annot"><a href="Features.Verbal.html#auxOrTrinko"><span class="hs-identifier">auxOrTrinko</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-9"></span><span>    </span><span class="annot"><a href="Features.Verbal.html#norConcord"><span class="hs-identifier">norConcord</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-10"></span><span>    </span><span class="annot"><a href="Features.Verbal.html#noriConcord"><span class="hs-identifier">noriConcord</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-11"></span><span>    </span><span class="annot"><a href="Features.Verbal.html#norkConcord"><span class="hs-identifier">norkConcord</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-12"></span><span>  </span><span class="hs-special">)</span><span>
</span><span id="line-13"></span><span class="hs-keyword">where</span><span>
</span><span id="line-14"></span><span>
</span><span id="line-15"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.Nominal.html"><span class="hs-identifier">Features.Nominal</span></a></span><span>
</span><span id="line-16"></span><span>
</span><span id="line-17"></span><span class="hs-comment">-- | Verbal features</span><span>
</span><span id="line-18"></span><span class="hs-keyword">data</span><span> </span><span id="VF"><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-var">VF</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span id="VF"><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-var">VF</span></a></span></span><span>
</span><span id="line-19"></span><span>  </span><span class="hs-special">{</span><span> </span><span id="tense"><span class="annot"><span class="annottext">VF -&gt; Tense
</span><a href="Features.Verbal.html#tense"><span class="hs-identifier hs-var hs-var">tense</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#Tense"><span class="hs-identifier hs-type">Tense</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-20"></span><span>    </span><span id="aspect"><span class="annot"><span class="annottext">VF -&gt; Aspect
</span><a href="Features.Verbal.html#aspect"><span class="hs-identifier hs-var hs-var">aspect</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#Aspect"><span class="hs-identifier hs-type">Aspect</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-21"></span><span>    </span><span id="nor"><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nor"><span class="hs-identifier hs-var hs-var">nor</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-22"></span><span>    </span><span id="nori"><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nori"><span class="hs-identifier hs-var hs-var">nori</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-23"></span><span>    </span><span id="nork"><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nork"><span class="hs-identifier hs-var hs-var">nork</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-24"></span><span>    </span><span id="instantiation"><span class="annot"><span class="annottext">VF -&gt; Instantiation
</span><a href="Features.Verbal.html#instantiation"><span class="hs-identifier hs-var hs-var">instantiation</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#Instantiation"><span class="hs-identifier hs-type">Instantiation</span></a></span><span>
</span><span id="line-25"></span><span>  </span><span class="hs-special">}</span><span>
</span><span id="line-26"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081582"><span id="local-6989586621679081584"><span class="annot"><span class="annottext">VF -&gt; VF -&gt; Bool
(VF -&gt; VF -&gt; Bool) -&gt; (VF -&gt; VF -&gt; Bool) -&gt; Eq VF
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: VF -&gt; VF -&gt; Bool
$c/= :: VF -&gt; VF -&gt; Bool
== :: VF -&gt; VF -&gt; Bool
$c== :: VF -&gt; VF -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081575"><span id="local-6989586621679081577"><span id="local-6989586621679081579"><span class="annot"><span class="annottext">Int -&gt; VF -&gt; ShowS
[VF] -&gt; ShowS
VF -&gt; String
(Int -&gt; VF -&gt; ShowS)
-&gt; (VF -&gt; String) -&gt; ([VF] -&gt; ShowS) -&gt; Show VF
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [VF] -&gt; ShowS
$cshowList :: [VF] -&gt; ShowS
show :: VF -&gt; String
$cshow :: VF -&gt; String
showsPrec :: Int -&gt; VF -&gt; ShowS
$cshowsPrec :: Int -&gt; VF -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-27"></span><span>
</span><span id="line-28"></span><span class="hs-comment">-- TODO: nor, nori, nork could be only (Person,Number)</span><span>
</span><span id="line-29"></span><span>
</span><span id="line-30"></span><span class="hs-comment">-- | Generate specified agreement on verb with given nominal features</span><span>
</span><span id="line-31"></span><span class="annot"><a href="Features.Verbal.html#norConcord"><span class="hs-identifier hs-type">norConcord</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Features.Verbal.html#noriConcord"><span class="hs-identifier hs-type">noriConcord</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Features.Verbal.html#norkConcord"><span class="hs-identifier hs-type">norkConcord</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span>
</span><span id="line-32"></span><span id="norConcord"><span class="annot"><span class="annottext">norConcord :: NF -&gt; VF -&gt; VF
</span><a href="Features.Verbal.html#norConcord"><span class="hs-identifier hs-var hs-var">norConcord</span></a></span></span><span> </span><span id="local-6989586621679081573"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081573"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span id="local-6989586621679081572"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679081572"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679081572"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">nor :: NF
</span><a href="Features.Verbal.html#nor"><span class="hs-identifier hs-var">nor</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081573"><span class="hs-identifier hs-var">nf</span></a></span><span class="hs-special">}</span><span>
</span><span id="line-33"></span><span id="noriConcord"><span class="annot"><span class="annottext">noriConcord :: NF -&gt; VF -&gt; VF
</span><a href="Features.Verbal.html#noriConcord"><span class="hs-identifier hs-var hs-var">noriConcord</span></a></span></span><span> </span><span id="local-6989586621679081571"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081571"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span id="local-6989586621679081570"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679081570"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679081570"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">nori :: NF
</span><a href="Features.Verbal.html#nori"><span class="hs-identifier hs-var">nori</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081571"><span class="hs-identifier hs-var">nf</span></a></span><span class="hs-special">}</span><span>
</span><span id="line-34"></span><span id="norkConcord"><span class="annot"><span class="annottext">norkConcord :: NF -&gt; VF -&gt; VF
</span><a href="Features.Verbal.html#norkConcord"><span class="hs-identifier hs-var hs-var">norkConcord</span></a></span></span><span> </span><span id="local-6989586621679081569"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081569"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span id="local-6989586621679081568"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679081568"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679081568"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">nork :: NF
</span><a href="Features.Verbal.html#nork"><span class="hs-identifier hs-var">nork</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081569"><span class="hs-identifier hs-var">nf</span></a></span><span class="hs-special">}</span><span>
</span><span id="line-35"></span><span>
</span><span id="line-36"></span><span class="hs-comment">-- | Convert VF into the describe Instantiation category</span><span>
</span><span id="line-37"></span><span class="annot"><a href="Features.Verbal.html#fullVerb"><span class="hs-identifier hs-type">fullVerb</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Features.Verbal.html#lexicalVerb"><span class="hs-identifier hs-type">lexicalVerb</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Features.Verbal.html#auxOrTrinko"><span class="hs-identifier hs-type">auxOrTrinko</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span>
</span><span id="line-38"></span><span id="fullVerb"><span class="annot"><span class="annottext">fullVerb :: VF -&gt; VF
</span><a href="Features.Verbal.html#fullVerb"><span class="hs-identifier hs-var hs-var">fullVerb</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Instantiation -&gt; VF -&gt; VF
</span><a href="Features.Verbal.html#changeVInstantiation"><span class="hs-identifier hs-var">changeVInstantiation</span></a></span><span> </span><span class="annot"><span class="annottext">Instantiation
</span><a href="Features.Verbal.html#Full"><span class="hs-identifier hs-var">Full</span></a></span><span>
</span><span id="line-39"></span><span id="lexicalVerb"><span class="annot"><span class="annottext">lexicalVerb :: VF -&gt; VF
</span><a href="Features.Verbal.html#lexicalVerb"><span class="hs-identifier hs-var hs-var">lexicalVerb</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Instantiation -&gt; VF -&gt; VF
</span><a href="Features.Verbal.html#changeVInstantiation"><span class="hs-identifier hs-var">changeVInstantiation</span></a></span><span> </span><span class="annot"><span class="annottext">Instantiation
</span><a href="Features.Verbal.html#Main"><span class="hs-identifier hs-var">Main</span></a></span><span>
</span><span id="line-40"></span><span id="auxOrTrinko"><span class="annot"><span class="annottext">auxOrTrinko :: VF -&gt; VF
</span><a href="Features.Verbal.html#auxOrTrinko"><span class="hs-identifier hs-var hs-var">auxOrTrinko</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Instantiation -&gt; VF -&gt; VF
</span><a href="Features.Verbal.html#changeVInstantiation"><span class="hs-identifier hs-var">changeVInstantiation</span></a></span><span> </span><span class="annot"><span class="annottext">Instantiation
</span><a href="Features.Verbal.html#AuxOrTrinko"><span class="hs-identifier hs-var">AuxOrTrinko</span></a></span><span>
</span><span id="line-41"></span><span>
</span><span id="line-42"></span><span class="annot"><a href="Features.Verbal.html#changeVInstantiation"><span class="hs-identifier hs-type">changeVInstantiation</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#Instantiation"><span class="hs-identifier hs-type">Instantiation</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span>
</span><span id="line-43"></span><span id="changeVInstantiation"><span class="annot"><span class="annottext">changeVInstantiation :: Instantiation -&gt; VF -&gt; VF
</span><a href="Features.Verbal.html#changeVInstantiation"><span class="hs-identifier hs-var hs-var">changeVInstantiation</span></a></span></span><span> </span><span id="local-6989586621679081563"><span class="annot"><span class="annottext">Instantiation
</span><a href="#local-6989586621679081563"><span class="hs-identifier hs-var">pos</span></a></span></span><span> </span><span id="local-6989586621679081562"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679081562"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679081562"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">instantiation :: Instantiation
</span><a href="Features.Verbal.html#instantiation"><span class="hs-identifier hs-var">instantiation</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Instantiation
</span><a href="#local-6989586621679081563"><span class="hs-identifier hs-var">pos</span></a></span><span class="hs-special">}</span><span>
</span><span id="line-44"></span><span>
</span><span id="line-45"></span><span class="hs-comment">-- | Aspectual features. Punctual is included only for irregular verbs.</span><span>
</span><span id="line-46"></span><span class="hs-keyword">data</span><span> </span><span id="Aspect"><span class="annot"><a href="Features.Verbal.html#Aspect"><span class="hs-identifier hs-var">Aspect</span></a></span></span><span>
</span><span id="line-47"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="Perfective"><span class="annot"><a href="Features.Verbal.html#Perfective"><span class="hs-identifier hs-var">Perfective</span></a></span></span><span>
</span><span id="line-48"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Imperfective"><span class="annot"><a href="Features.Verbal.html#Imperfective"><span class="hs-identifier hs-var">Imperfective</span></a></span></span><span>
</span><span id="line-49"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Future"><span class="annot"><a href="Features.Verbal.html#Future"><span class="hs-identifier hs-var">Future</span></a></span></span><span>
</span><span id="line-50"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Punctual"><span class="annot"><a href="Features.Verbal.html#Punctual"><span class="hs-identifier hs-var">Punctual</span></a></span></span><span>
</span><span id="line-51"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081552"><span id="local-6989586621679081554"><span id="local-6989586621679081556"><span class="annot"><span class="annottext">Int -&gt; Aspect -&gt; ShowS
[Aspect] -&gt; ShowS
Aspect -&gt; String
(Int -&gt; Aspect -&gt; ShowS)
-&gt; (Aspect -&gt; String) -&gt; ([Aspect] -&gt; ShowS) -&gt; Show Aspect
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Aspect] -&gt; ShowS
$cshowList :: [Aspect] -&gt; ShowS
show :: Aspect -&gt; String
$cshow :: Aspect -&gt; String
showsPrec :: Int -&gt; Aspect -&gt; ShowS
$cshowsPrec :: Int -&gt; Aspect -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081548"><span id="local-6989586621679081550"><span class="annot"><span class="annottext">Aspect -&gt; Aspect -&gt; Bool
(Aspect -&gt; Aspect -&gt; Bool)
-&gt; (Aspect -&gt; Aspect -&gt; Bool) -&gt; Eq Aspect
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: Aspect -&gt; Aspect -&gt; Bool
$c/= :: Aspect -&gt; Aspect -&gt; Bool
== :: Aspect -&gt; Aspect -&gt; Bool
$c== :: Aspect -&gt; Aspect -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-52"></span><span>
</span><span id="line-53"></span><span class="hs-comment">-- Punctual is to be used in synthetic forms only</span><span>
</span><span id="line-54"></span><span>
</span><span id="line-55"></span><span class="hs-keyword">data</span><span> </span><span id="Tense"><span class="annot"><a href="Features.Verbal.html#Tense"><span class="hs-identifier hs-var">Tense</span></a></span></span><span>
</span><span id="line-56"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="Past"><span class="annot"><a href="Features.Verbal.html#Past"><span class="hs-identifier hs-var">Past</span></a></span></span><span>
</span><span id="line-57"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Present"><span class="annot"><a href="Features.Verbal.html#Present"><span class="hs-identifier hs-var">Present</span></a></span></span><span>
</span><span id="line-58"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081540"><span id="local-6989586621679081542"><span id="local-6989586621679081544"><span class="annot"><span class="annottext">Int -&gt; Tense -&gt; ShowS
[Tense] -&gt; ShowS
Tense -&gt; String
(Int -&gt; Tense -&gt; ShowS)
-&gt; (Tense -&gt; String) -&gt; ([Tense] -&gt; ShowS) -&gt; Show Tense
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Tense] -&gt; ShowS
$cshowList :: [Tense] -&gt; ShowS
show :: Tense -&gt; String
$cshow :: Tense -&gt; String
showsPrec :: Int -&gt; Tense -&gt; ShowS
$cshowsPrec :: Int -&gt; Tense -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081536"><span id="local-6989586621679081538"><span class="annot"><span class="annottext">Tense -&gt; Tense -&gt; Bool
(Tense -&gt; Tense -&gt; Bool) -&gt; (Tense -&gt; Tense -&gt; Bool) -&gt; Eq Tense
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: Tense -&gt; Tense -&gt; Bool
$c/= :: Tense -&gt; Tense -&gt; Bool
== :: Tense -&gt; Tense -&gt; Bool
$c== :: Tense -&gt; Tense -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-59"></span><span>
</span><span id="line-60"></span><span class="hs-comment">-- | This feature is not a linguistic category. It is necessary because we</span><span>
</span><span id="line-61"></span><span class="hs-comment">--  might want to instantiate only the auxiliary or main parts of the verb.</span><span>
</span><span id="line-62"></span><span class="hs-keyword">data</span><span> </span><span id="Instantiation"><span class="annot"><a href="Features.Verbal.html#Instantiation"><span class="hs-identifier hs-var">Instantiation</span></a></span></span><span>
</span><span id="line-63"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="Full"><span class="annot"><a href="Features.Verbal.html#Full"><span class="hs-identifier hs-var">Full</span></a></span></span><span>
</span><span id="line-64"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Main"><span class="annot"><a href="Features.Verbal.html#Main"><span class="hs-identifier hs-var">Main</span></a></span></span><span>
</span><span id="line-65"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="AuxOrTrinko"><span class="annot"><a href="Features.Verbal.html#AuxOrTrinko"><span class="hs-identifier hs-var">AuxOrTrinko</span></a></span></span><span>
</span><span id="line-66"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081530"><span id="local-6989586621679081532"><span id="local-6989586621679081534"><span class="annot"><span class="annottext">Int -&gt; Instantiation -&gt; ShowS
[Instantiation] -&gt; ShowS
Instantiation -&gt; String
(Int -&gt; Instantiation -&gt; ShowS)
-&gt; (Instantiation -&gt; String)
-&gt; ([Instantiation] -&gt; ShowS)
-&gt; Show Instantiation
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Instantiation] -&gt; ShowS
$cshowList :: [Instantiation] -&gt; ShowS
show :: Instantiation -&gt; String
$cshow :: Instantiation -&gt; String
showsPrec :: Int -&gt; Instantiation -&gt; ShowS
$cshowsPrec :: Int -&gt; Instantiation -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081526"><span id="local-6989586621679081528"><span class="annot"><span class="annottext">Instantiation -&gt; Instantiation -&gt; Bool
(Instantiation -&gt; Instantiation -&gt; Bool)
-&gt; (Instantiation -&gt; Instantiation -&gt; Bool) -&gt; Eq Instantiation
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: Instantiation -&gt; Instantiation -&gt; Bool
$c/= :: Instantiation -&gt; Instantiation -&gt; Bool
== :: Instantiation -&gt; Instantiation -&gt; Bool
$c== :: Instantiation -&gt; Instantiation -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-67"></span></pre></body></html>